import json

from Market.Order import Order

class BuyOrder(Order):
    def __init__(self, cardId=None, price=0, volume=0, fee=0):
        super().__init__(
            orderType = "buy",
            cardId = cardId,
            fee = fee
            )
        self.price = price
        self.volume = volume

    def add_transaction(self, transaction):
        if len(self.transactions) < self.volume:
            # TODO: update database
            self.transactions.append(transaction)
        else:
            raise self.Fulfilled("Order volume has already been fulfilled.")

    def __str__(self):
        return json.dumps({
            "orderId": str(self.orderId),
            "timestamp": str(self.timestamp)
            "userId": str(self.userId)
            "orderType": str(self.orderType),
            "cardId": self.cardId,
            "price": self.price,
            "volume": self.volume,
            "fee": self.fee,
            "transactions": [str(each) for each in self.transactions]
            })
