import datetime
import data
import uuid

class Transaction():
    def __init__(self, transactionId=uuid.uuid4(),
                 timestamp=datetime.datetime.now(datetime.timezone.utc),
                 cardId=None, sender=None, receiver=None, signature=None, data=None):
        self.transactionId = transactionId
        self.timestamp = timestamp
        self.cardId = cardId
        self.sender = sender
        self.receiver = receiver
        self.signature = signature
        if data:
            self.load_from_data(data)

    def validate(self):
        # TODO: validate transactionId
        # TODO: validate timestamp
        # TODO: validate cardId
        # TODO: validate sender
        # TODO: validate receiver
        # TODO: validate signature
        if False:
            raise self.Unauthorized()
        elif False:
            raise self.Invalid()

    def sign(self, privateKey):
        # TODO: use rsa private key to sign block
        return None

    def load_from_data(self, data):
        self.transactionId = uuid.UUID(data['transactionId'])
        self.timestamp = datetime.datetime.strptime(
            data['timestamp'],
            "%Y-%m-%d %H:%M:%S.%f%z"
            )
        self.cardId = uuid.UUID(data['cardId'])
        self.sender = data['sender']
        self.receiver = data['receiver']
        self.signature = data['signature']


    def __str__(self):
        return data.dumps({
            "transactionId": str(self.id),
            "timestamp": str(self.timestamp),
            "cardId": self.cardId,
            "sender": self.sender,
            "receiver": self.receiver,
            "signature": self.signature
            })

    class Unauthorized(Exception):
        def __init__(self, message, statusCode=403):
            super().__init__(message)
            self.statusCode = statusCode

    class Invalid(Exception):
        def __init__(self, message, statusCode=400):
            super().__init__(message)
            self.statusCode = statusCode

    class AlreadyFulfilled(Exception):
        def __init__(self, message, statusCode=400):
            super().__init__(message)
            self.statusCode = statusCode

    class Abandoned(Exception):
        def __init__(self, message, statusCode=500):
            super().__init__(message)
            self.statusCode = statusCode
