import os
import dotenv

ROLE = os.getenv("ROLE", None)
INTERVAL = os.getenv("INTERVAL", 15)

if __name__ == "__main__":
    dotenv.load_dotenv()
    if ROLE == "market":
        from Market.Market import market
        market.run()
    elif ROLE == "mine":
        from Mine.Mine import mine
        mine.run()
    elif ROLE == "order_matcher":
        from OrderMatcher.OrderMatcher import OrderMatcher
        import time
        orderMatcher = OrderMatcher()
        while True:
            orderMatcher.match_orders()
            time.sleep(INTERVAL)
    elif ROLE == "status_checker":
        from StatusChecker.StatusChecker import StatusChecker
        import time
        statusChecker = StatusChecker()
        while True:
            statusChecker.update_pending_transactions()
            time.sleep(INTERVAL)
    else:
        raise Exception("Role must be one of: market, mine, order_matcher, status_checker")
